//Title:        Esercitazione04: applicazione "computer" 
//Version:      1.0
//Copyright:    Copyright (c) 2006
//Author:       Ilaria Bartolini
//Company:      DEIS - University of Bologna

import java.sql.*;
import java.io.*;
import java.util.*;

class Computer {

   static {
      try {
         // register the driver with DriverManager
         Class.forName("COM.ibm.db2.jdbc.app.DB2Driver").newInstance();
      } catch (Exception e) {
         e.printStackTrace();
      }
   }
   
   public static void main(String argv[]) {
      Connection con = null;
	try{
	
      // URL is jdbc:db2:dbname
      String url = "jdbc:db2:studenti";

      try {
        if (argv.length == 2) {
            String userid = argv[0];
            String passwd = argv[1];

            // connect with user-provided username and password
            con = DriverManager.getConnection(url, userid, passwd);
            }
         else {
            System.out.println("\nUsage: java Esame [username password]\n");
            System.exit(0);
         }
     System.out.println("...sono pronto per iniziare!");
     
     Statement stmt = con.createStatement();
     
     
     try
     {
     	stmt.executeUpdate("drop table software");
     	
     }
     catch(Exception e){
     }
     try
     {
     	stmt.executeUpdate("drop table installazioni");
     	
     }
     catch(Exception e){
     }

	try
     {
     	stmt.executeUpdate("drop table pc");
     	
     }
     catch(Exception e){
     }
     
     stmt.executeUpdate("create table software( "+
     					"codsw char(5) not null primary key, "+
     					"tipo varchar(20) not null, "+
    					"numlicenze int not null)");
     
      					
     stmt.executeUpdate("create table pc( "+
     					"codpc char(5) not null primary key, "+
     					"proprietario varchar(20) not null, indirizzoip varchar(15) not null)");
     
     
     
     stmt.executeUpdate("create table installazioni( "+
     					"codsw char(5) not null references software(codsw), "+
     					"codpc char(5) not null references pc(codpc), "+
    					"installatore varchar(20) not null, "+
     					"data date not null,primary key(codsw,codpc))");
     					
    
     
     stmt.executeUpdate("insert into software values('soft1','gestionale',4),('soft2','gioco',2),('soft3','ide',7),"+
     					"('soft4','virtualmachine',5),('soft5','SO',11),('soft6','ide',3)");
     
     stmt.executeUpdate("insert into pc values('comp1','Enrico','137.204.57'),('comp2','Bill','137.204.7'),('comp3','Steven','137.200.57'),"+
     					"('comp4','Linux','137.204.57'),('comp5','Alfred','128.205.17'),('comp6','Albert','100.200.0')");
     
     stmt.executeUpdate("insert into installazioni values('soft5','comp1','Giovanni','10.10.2006'),('soft2','comp2','Alberto','11.11.2006'),"+
     					"('soft3','comp3','Giovanni','9.9.2006'),('soft1','comp4','Alberto','7.7.2000'),('soft3','comp2','Giovanni','8.8.2006'),"+
     					"('soft6','comp5','Giovanni','5.5.2006')");
     
     					
     
     ResultSet rs=stmt.executeQuery("select p.codpc,count(*) from pc p,installazioni i,software s where p.codpc=i.codpc and i.codsw=s.codsw and s.numlicenze>=10 group by p.codpc");
     
     PrintWriter pw=new PrintWriter(new FileWriter("query1.txt"));
    
     String pc;
     int num;
     
     while(rs.next())
     {
     	try{
     		pc=rs.getString(1);
     		num=rs.getInt(2);
     		pw.println(pc+" , "+num);
     	}catch(Exception e){e.printStackTrace();}
     }
    
   
    rs=stmt.executeQuery("select s.codsw from software s,installazioni i where s.codsw=i.codsw and i.data<='8.8.2001'");
    PrintWriter pw2=new PrintWriter(new FileWriter("query2.txt"));
   
    String soft;
    while(rs.next())
    {
    	soft=rs.getString(1);
    	
    	pw2.println(soft);
    }
     
     pw.close();
     pw2.close();
     rs.close();
     stmt.close();
     con.close(); 
     
    } catch( Exception e ) {
         e.printStackTrace();
    }
          
  }catch(Exception e ){e.printStackTrace();}
  }
}